VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   6060
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7560
   LinkTopic       =   "Form1"
   ScaleHeight     =   6060
   ScaleWidth      =   7560
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picColor 
      BackColor       =   &H00FFC0FF&
      BorderStyle     =   0  'None
      Height          =   495
      Index           =   6
      Left            =   3600
      ScaleHeight     =   495
      ScaleWidth      =   495
      TabIndex        =   9
      Top             =   1080
      Width           =   495
   End
   Begin VB.PictureBox picColor 
      BackColor       =   &H00FFC0C0&
      BorderStyle     =   0  'None
      Height          =   495
      Index           =   5
      Left            =   3000
      ScaleHeight     =   495
      ScaleWidth      =   495
      TabIndex        =   8
      Top             =   1080
      Width           =   495
   End
   Begin VB.PictureBox picColor 
      BackColor       =   &H00FFFFC0&
      BorderStyle     =   0  'None
      Height          =   495
      Index           =   4
      Left            =   2400
      ScaleHeight     =   495
      ScaleWidth      =   495
      TabIndex        =   7
      Top             =   1080
      Width           =   495
   End
   Begin VB.PictureBox picColor 
      BackColor       =   &H00C0FFC0&
      BorderStyle     =   0  'None
      Height          =   495
      Index           =   3
      Left            =   1800
      ScaleHeight     =   495
      ScaleWidth      =   495
      TabIndex        =   6
      Top             =   1080
      Width           =   495
   End
   Begin VB.PictureBox picColor 
      BackColor       =   &H00C0FFFF&
      BorderStyle     =   0  'None
      Height          =   495
      Index           =   2
      Left            =   1200
      ScaleHeight     =   495
      ScaleWidth      =   495
      TabIndex        =   5
      Top             =   1080
      Width           =   495
   End
   Begin VB.PictureBox picColor 
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      Height          =   495
      Index           =   1
      Left            =   600
      ScaleHeight     =   495
      ScaleWidth      =   495
      TabIndex        =   4
      Top             =   1080
      Width           =   495
   End
   Begin VB.PictureBox picColor 
      Height          =   495
      Index           =   0
      Left            =   0
      ScaleHeight     =   435
      ScaleWidth      =   435
      TabIndex        =   3
      Top             =   1080
      Width           =   495
   End
   Begin VB.TextBox txtHTML 
      Height          =   855
      Left            =   0
      MultiLine       =   -1  'True
      TabIndex        =   2
      Top             =   1680
      Width           =   2055
   End
   Begin VB.TextBox txtSource 
      Height          =   855
      Left            =   0
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   0
      Width           =   2055
   End
   Begin VB.CommandButton cmdConvert 
      Caption         =   "Convert"
      Height          =   495
      Left            =   4200
      TabIndex        =   0
      Top             =   1080
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private SelectedColor As Integer
' Put bold delimiters around comments.
Private Function BoldComments(ByVal txt As String) As String
Dim pos As Integer
Dim ch As String
Dim quote_open As Boolean

    ' Find the first ' not inside quotes.
    For pos = 1 To Len(txt)
        ch = Mid$(txt, pos, 1)
        If ch = """" Then
            quote_open = Not quote_open
        ElseIf (ch = "'") And (Not quote_open) Then
            ' We found it. Stop here.
            Exit For
        End If
    Next pos

    If pos <= Len(txt) Then
        ' We have a comment.
        BoldComments = Left$(txt, pos - 1) & _
            "<B>'" & Mid$(txt, pos + 1) & "</B>"
    Else
        ' We have no comment.
        BoldComments = txt
    End If
End Function

' Replace from_str with to_str.
Private Function ReplaceString(ByVal txt As String, ByVal from_str As String, ByVal to_str As String) As String
Dim result As String
Dim pos As Integer

    result = ""
    Do
        pos = InStr(txt, from_str)
        If pos = 0 Then Exit Do

        result = result & _
            Left$(txt, pos - 1) & _
            to_str
        txt = Mid$(txt, pos + Len(from_str))
    Loop

    result = result & txt
    ReplaceString = result
End Function

' Build an HTML table representing source code.
Private Function SourceToHTML(ByVal source_text As String) As String
Dim bg_string As String
Dim bg_color As Long
Dim bg_red As Integer
Dim bg_green As Integer
Dim bg_blue As Integer
Dim txt As String
Dim pos As Integer
Dim next_line As String

    txt = ""

    ' Compute the selected color.
    If SelectedColor = 0 Then
        bg_string = ""
    Else
        bg_color = picColor(SelectedColor).BackColor
        bg_red = bg_color And &HFF&
        bg_green = (bg_color And &HFF00&) \ &H100&
        bg_blue = (bg_color And &HFF0000) \ &H10000
        bg_string = Hex$(bg_red) & Hex$(bg_green) & Hex$(bg_blue)
    End If

    ' If the background color is not blank,
    ' use a table.
    If Len(bg_string) > 0 Then
        ' Start the table.
        txt = txt & "<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=2 BGCOLOR=#" & bg_string & ">" & vbCrLf
        txt = txt & "<TR><TD>" & vbCrLf
    End If

    ' Start TT PRE.
    txt = txt & "<TT><PRE>"

    Do While Len(source_text) > 0
        ' Get the next line.
        pos = InStr(source_text, vbCrLf)
        If pos = 0 Then
            next_line = source_text
            source_text = ""
        Else
            next_line = Left$(source_text, pos - 1)
            source_text = Mid$(source_text, pos + Len(vbCrLf))
        End If

        ' Replace special symbols.
        next_line = ReplaceString(next_line, "&", "&amp;")
        next_line = ReplaceString(next_line, "<", "&lt;")
        next_line = ReplaceString(next_line, ">", "&gt;")

        ' Bold comments.
        next_line = BoldComments(next_line)

        ' Now replace the double quotes.
        next_line = ReplaceString(next_line, """", "&quot;")

        ' Add this line to the result.
        txt = txt & next_line & vbCrLf
    Loop

    ' Remove the final vbCrLf and end PRE TT.
    txt = Left$(txt, Len(txt) - Len(vbCrLf))
    txt = txt & "</PRE></TT>" & vbCrLf

    ' If the background color is not blank,
    ' finish the table.
    If Len(bg_string) > 0 Then
        txt = txt & "</TD></TR>" & vbCrLf
        txt = txt & "</TABLE>" & vbCrLf
    End If

    SourceToHTML = txt
End Function
Private Sub cmdConvert_Click()
    txtHTML.Text = SourceToHTML(txtSource.Text)
End Sub
' Draw an X on picColor(0) to represent no table.
Private Sub Form_Load()
    picColor(0).AutoRedraw = True
    picColor(0).Line (0, 0)-(picColor(0).ScaleWidth, picColor(0).ScaleHeight)
    picColor(0).Line (picColor(0).ScaleWidth, 0)-(0, picColor(0).ScaleHeight)
End Sub

Private Sub Form_Resize()
Const GAP = 30

Dim hgt As Single
Dim i As Integer

    hgt = (ScaleHeight - cmdConvert.Height - 2 * GAP) / 2
    If hgt < 120 Then hgt = 120
    txtSource.Move 0, 0, ScaleWidth, hgt
    cmdConvert.Move cmdConvert.Left, hgt + GAP
    txtHTML.Move 0, _
        cmdConvert.Top + cmdConvert.Height + GAP, _
        ScaleWidth, hgt

    For i = picColor.LBound To picColor.uBound
        picColor(i).Top = cmdConvert.Top
    Next i
End Sub

Private Sub picColor_Click(Index As Integer)
    picColor(SelectedColor).BorderStyle = vbBSNone
    SelectedColor = Index
    picColor(SelectedColor).BorderStyle = vbFixedSingle
End Sub


